package servant;

import idl.SamplePOA;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;

import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

public class Servant extends SamplePOA {

	private static final String IOR_FILE = "ior.txt";

	public static void main(String[] args) {
		try {
			for (String a : args) {
				System.out.println(a);
			}
			ORB orb = ORB.init(args, System.getProperties());

			POA poa = POAHelper.narrow(orb
					.resolve_initial_references("RootPOA"));
			poa.the_POAManager().activate();

			Servant servant = new Servant();
			Object obj = poa.servant_to_reference(servant);

			PrintWriter pw = new PrintWriter(new FileWriter(IOR_FILE));
			String ior = orb.object_to_string(obj);
			pw.println(ior);
			pw.flush();
			pw.close();

			System.out.println("[Servant]ior = " + ior);
			System.out.println("[Servant]Waiting client connection....");

			orb.run();

			orb.shutdown(true);
			orb.destroy();

		} catch (Exception e) {
			System.err.println("[Servant]Exception occured !!");
			e.printStackTrace();
		} finally {
			File file = new File(IOR_FILE);
			try {
				file.delete();
			} catch (Exception ex) {
				// nothing
			}
		}
	}

	public Servant() {
		super();
	}

	public String getHello(String name) {
		System.out.println("[Servant]Recieving connection !");
		return "Hello " + name + " !!";
	}

}
